#pragma once
#include<ns3/v4ping-helper.h>
#include <ns3/v4traceroute-helper.h>
#include <ns3/point-to-point-helper.h>
#include<ns3/dhcp-helper.h>

using namespace ns3;
class Host {
public:
	ApplicationContainer installed_apps;
	ns3::Ipv4InterfaceContainer ip;
	ns3::Ptr<ns3::Node>node;
	Host(ns3::Ptr<ns3::Node>node) {
		this->node = node;

	}
	void Ping(std::string Target_IP,int time) {
		ns3::V4PingHelper ping(Target_IP.c_str());
		Time interPacketInterval = Seconds(1.0);
		ping.SetAttribute("Interval", TimeValue(interPacketInterval));
		ping.SetAttribute("Verbose", BooleanValue(true));
		ping.SetAttribute("Size", UintegerValue(1024));
		ApplicationContainer app = ping.Install(node);
		app.Start(ns3::Seconds(time));
		app.Stop(ns3::Seconds(time + 10));
		installed_apps.Add(app);
		
	}
	void TraceRoute(std::string Target_IP, int time) {
		ns3::V4TraceRouteHelper traceroute(Target_IP.c_str());
		traceroute.SetAttribute("Verbose", BooleanValue(true));
		ApplicationContainer app = traceroute.Install(node);
		app.Start(ns3::Seconds(time));
		installed_apps.Add(app);
		//Ptr<OutputStreamWrapper> printstrm = Create<OutputStreamWrapper>(&std::cout);
		//traceroute.PrintTraceRouteAt(node, printstrm);
	}
	void Ping(ns3::Ipv4Address Target_IP, int time) {
		ns3::V4PingHelper ping(Target_IP);
		Time interPacketInterval = Seconds(1.0);
		ping.SetAttribute("Interval", TimeValue(interPacketInterval));
		ping.SetAttribute("Verbose", BooleanValue(true));
		ping.SetAttribute("Size", UintegerValue(1024));
		ApplicationContainer app = ping.Install(node);
		app.Start(ns3::Seconds(time));
		app.Stop(ns3::Seconds(time+10));
		installed_apps.Add(app);
	}
	void TraceRoute(ns3::Ipv4Address Target_IP, int time) {
		ns3::V4TraceRouteHelper traceroute(Target_IP);
		traceroute.SetAttribute("Verbose", BooleanValue(true));
		ApplicationContainer app = traceroute.Install(node);
		app.Start(ns3::Seconds(time));
		installed_apps.Add(app);
		//Ptr<OutputStreamWrapper> printstrm = Create<OutputStreamWrapper>(&std::cout);
		//traceroute.PrintTraceRouteAt(node, printstrm);
	}
	
};